<?php

namespace App\Jobs\Mass\MassDelete;

use App\Tasks\Mass\MassDelete\MassDelete3Task;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;

class MassDelete3Job implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * The number of seconds the job can run before timing out.
     *
     * @var int
     */
    public int $timeout = 3600; //20min

    /**
     * Create a new job instance.
     */
    public function __construct(public int $count)
    {
        //
    }

    /**
     * Execute the job.
     */
    public function handle(): void
    {
        (new MassDelete3Task())->handle($this->count);
    }
}
