<?php

namespace App\Tasks\Mass\MassDelete;

use App\Models\Transaction;
use App\Tasks\Mass\MassInsert\MassInsert3Task;
use Illuminate\Support\Collection;

class MassDelete2Task
{

    /**
     * insert unit
     *
     *       100 ............ 0,018 s DONE
     *     1_000 ............ 0,105 s DONE
     *    10_000 ............ 0,938 s DONE
     *   100_000 ........... 10,000 s DONE
     * 1_000_000 .......... 109,000 s DONE (1m 49s)
     */
    public function handle(int $count): void
    {
        (new MassInsert3Task)->handle($count);

        Transaction::query()
            ->select([
                'id',
            ])
            ->where('id', '>', 0)
            ->chunkById(1000, function ($transactions) {
                /** @var Collection $transactions */
                Transaction::query()
                    ->whereIn('id', $transactions->pluck('id'))
                    ->delete();
            });
    }
}
